function out = error_function(parameters,input_data,time,study)
%% simulate model for a given parameter set

parameters = parameter_set(parameters);

[initial_values,constants]=initial_set(parameters,input_data);

ODE_options = odeset('RelTol',1e-5);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);

%% Calculate error 

if study==1  || study==2 %in case of a new study with different number of data points for glucose and insulin

measured_time=ismember(T,input_data.time);

G_err = (X(measured_time,2)' - input_data.glucose(1,:));
I_err = (X(measured_time,4)' - input_data.insulin(1,:))./10; %to normalize the scale difference of insulin levels

out=[G_err,I_err];

end

