function out = generate_initials(initial_par,lb,ub,noise,num_par)

out=zeros(num_par,numel(initial_par));
for i=1:num_par
    %generate random parameter set by adding noise to initial_par
    noise_par = initial_par+initial_par.*noise.*(1-2*rand(1,numel(initial_par)));
    %ensure all generated parameter values are greater than their respective lower bound
    too_low = noise_par<lb;
    %if generated parameter values is below the lower bound for parameter
    %estimation it is replaced with the lower bound
    noise_par(too_low) = lb(too_low);
    %ensure all generated parameter values are lower than their respective upper bound
    too_high = noise_par>ub;
    %if generated parameter values is above the upper bound for parameter
    %estimation it is replaced with that upper bound
    noise_par(too_high) = ub(too_high);
    out(i,:) = noise_par;
end