function out=sensitivity_analysis(factor, s, p_opt, input_data, time)

ODE_options = odeset('RelTol',1e-5);

if factor==1
%Sensitivity Analysis to reference point parameters

%to Gref
parameters = parameter_set(p_opt);
color=[];
figure()
for i=1:size(s.Gref,2)
parameters(11)=s.Gref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 0.1,1*i*0.01,0];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.Gref(1,1) s.Gref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Glucose (mmol/L)');
colormap(color)

color=[];
figure()
for i=1:size(s.Gref,2)
parameters(11)=s.Gref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color=[color; 0.1,1*i*0.01,0];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.Gref(1,1) s.Gref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Glucose (mmol/L)');
colormap(color)

%to Iref

parameters = parameter_set(p_opt);
color=[];
figure()
for i=1:size(s.Iref,2)
parameters(12)=s.Iref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 1.9*i*0.01,0,0.5];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.Iref(1,1) s.Iref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Insulin (mU/L)');
colormap(color)

color=[];
figure()
for i=1:size(s.Iref,2)
parameters(12)=s.Iref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color=[color; 1.9*i*0.01,0,0.5];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.Iref(1,1) s.Iref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Insulin (mU/L)');
colormap(color)

%to ISref

parameters = parameter_set(p_opt);
color=[];
figure()
for i=1:size(s.ISref,2)
parameters(13)=s.ISref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 1.9*i*0.01,0.5,0.8];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.ISref(1,1) s.ISref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Insulin Secretion (mU/L/min)');
colormap(color)

color=[];
figure()
for i=1:size(s.ISref,2)
parameters(13)=s.ISref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 1.9*i*0.01,0.5,0.8];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.ISref(1,1) s.ISref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Insulin Secretion (mU/L/min)');
colormap(color)

%to Uidref

parameters = parameter_set(p_opt);
color=[];
figure()
for i=1:size(s.Uidref,2)
parameters(15)=s.Uidref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
% color = [color; 3*i*0.01,0,0.5];
color = [color; 3*i*0.01,0.5,0.5];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.Uidref(1,1) s.Uidref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Glucose Uptake (mmol/L/min)');
colormap(color)

color=[];
figure()
for i=1:size(s.Uidref,2)
parameters(15)=s.Uidref(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
% color = [color; 3*i*0.01,0,0.5];
color = [color; 3*i*0.01,0.5,0.5];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.Uidref(1,1) s.Uidref(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Reference Glucose Uptake (mmol/L/min)');
colormap(color)

end

% sensitivity analysis to initial values

if factor==2
    parameters = parameter_set(p_opt);
    
%to plasma glucose initial value  
color=[];
figure()
for i=1:size(s.input_data.glucose,2)
input_data.glucose=s.input_data.glucose(1,i);
input_data.insulin=5;
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 0.1,1*i*0.01,0];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.input_data.glucose(1,1) s.input_data.glucose(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Initial Plasma Glucose (mmol/L)');
colormap(color)


color=[];
figure()
for i=1:size(s.input_data.glucose,2)
input_data.glucose=s.input_data.glucose(1,i);
input_data.insulin=5;
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color=[color; 0.1,1*i*0.01,0];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.input_data.glucose(1,1) s.input_data.glucose(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Initial Plasma Glucose (mmol/L)');
colormap(color)

%to plasma insulin initial value

input_data.glucose=[];
input_data.insulin=[];

color=[];
figure()
for i=1:size(s.input_data.insulin,2)
input_data.glucose=4;
input_data.insulin=s.input_data.insulin(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 1.6*i*0.01,0,0.5];
plot(T, X(:,2),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Glucose Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mmol/L')
caxis([s.input_data.insulin(1,1) s.input_data.insulin(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Initial Plasma Insulin (mU/L)');
colormap(color)


color=[];
figure()
for i=1:size(s.input_data.insulin,2)
input_data.glucose=4;
input_data.insulin=s.input_data.insulin(1,i);
[initial_values, constants]=initial_set(parameters,input_data);
[T,X] = ode45(@ODE_set,time,initial_values,ODE_options,parameters,constants,input_data);
color = [color; 1.6*i*0.01,0,0.5];
plot(T, X(:,4),'Color', color(i,:),'LineWidth', 2, 'LineWidth', 1)
hold on
end
title('Plasma Insulin Concentration')
xticks(input_data.time)
xlabel('min')
ylabel('mU/L')
caxis([s.input_data.insulin(1,1) s.input_data.insulin(1,end)]);
h = colorbar;
set(get(h,'label'),'string','Initial Plasma Insulin (mU/L)');
colormap(color)
 
end

